//---------------------------------------------------------------------------
// Written by Chris Maunder (chrismaunder@codeguru.com)
// Extended by Alexander Bischofberger (bischofb@informatik.tu-muenchen.de)
// Copyright (c) 1998.
//
// This code may be used in compiled form in any way you desire. This
// file may be redistributed unmodified by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name is included. If 
// the source code in  this file is used in any commercial application 
// then a simple email would be nice.
//
// This file is provided "as is" with no expressed or implied warranty.
// The author accepts no liability if it causes any damage whatsoever.
// It's free - so you get what you pay for.
//---------------------------------------------------------------------------

#if !defined(AFX_COLORPICKER_H__D0B75901_9830_11D1_9C0F_00A0243D1382__INCLUDED_)
#define AFX_COLORPICKER_H__D0B75901_9830_11D1_9C0F_00A0243D1382__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


#include "ColorPopup.h"

void AFXAPI DDX_ColorPicker(CDataExchange *pDX, int nIDC, COLORREF& crColor);;

class CColorPicker : public CButton
{
public:
    DECLARE_DYNCREATE(CColorPicker);

    CColorPicker();
    virtual ~CColorPicker();

    COLORREF		GetColor();
    void			SetColor(COLORREF crColor); 
					
    void			SetDefaultText(LPCTSTR szDefaultText);
    void			SetCustomText(LPCTSTR szCustomText);
					
    void			SetTrackSelection(BOOL bTracking = TRUE);
    BOOL			GetTrackSelection();
					
    void			SetSelectionMode(UINT nMode);
    UINT			GetSelectionMode();
					
    virtual void	DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);

protected:
    virtual void	PreSubclassWindow();
    void			SetWindowSize();
    afx_msg BOOL	OnClicked();
    afx_msg int		OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg LRESULT	OnSelEndOK(WPARAM wParam, LPARAM lParam);
    afx_msg LRESULT	OnSelEndCancel(WPARAM wParam, LPARAM lParam);
    afx_msg LRESULT	OnSelChange(WPARAM wParam, LPARAM lParam);

    DECLARE_MESSAGE_MAP()

private:
	BOOL			m_bActive,                // Is the dropdown active?
					m_bTrackSelection;        // track Color changes?
    COLORREF		m_crColor;
    CRect			m_ArrowRect;
    CString			m_strDefaultText;
    CString			m_strCustomText;
};

//---------------------------------------------------------------------------
// SetTrackSelection
//---------------------------------------------------------------------------
inline void			
CColorPicker::SetTrackSelection(BOOL bTracking /*= TRUE*/)
{
	m_bTrackSelection = bTracking;
}

//---------------------------------------------------------------------------
// GetTrackSelection
//---------------------------------------------------------------------------
inline BOOL			
CColorPicker::GetTrackSelection()                       
{
	return m_bTrackSelection;
}

#endif // !defined(AFX_COLORPICKER_H__D0B75901_9830_11D1_9C0F_00A0243D1382__INCLUDED_)
