; waplugin.nsi
;
; This script will generate an installer that installs a Winamp 2 plug-in.
;
; This installer will automatically alert the user that installation was
; successful, and ask them whether or not they would like to make the 
; plug-in the default and run Winamp.

;--------------------------------

; The name of the installer
Name "Quick Title Plug-in Version 2.2"

; The file to write
OutFile "gen_qtitle_install.exe"

; The default installation directory
InstallDir $PROGRAMFILES\Winamp

; detect winamp path from uninstall string if available
InstallDirRegKey HKLM \
                 "Software\Microsoft\Windows\CurrentVersion\Uninstall\Winamp" \
                 "UninstallString"

; The text to prompt the user to enter a directory
DirText "Please select your Winamp path below (you will be able to proceed when Winamp is detected):"
# currently doesn't work - DirShow hide

; automatically close the installer when done.
AutoCloseWindow false

; hide the "show details" box
ShowInstDetails show

FileErrorText "Please shutdown Winamp then press Retry."

;--------------------------------

;Pages

Page directory
Page instfiles

;--------------------------------

; The stuff to install

Section ""

  SetOutPath "$INSTDIR\plugins" 

  ; File to extract
  File "release\gen_qtitle.dll"
  File "gen_qtitle.txt"

  Exec 'notepad.exe "$INSTDIR\plugins\gen_qtitle.txt"'

SectionEnd

;--------------------------------

Function .onVerifyInstDir

  ;Check for Winamp installation

  IfFileExists $INSTDIR\Winamp.exe Good
    Abort
  Good:

FunctionEnd


